package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.*;

public class Bot extends AbstractBehavior<Bot.Message> {

    public interface Message {};

    public static class Start implements Message {
        ActorRef<Bot.Message> next;
        ActorRef<Bot.Message> nextnext;

        public Start(ActorRef<Bot.Message> next, ActorRef<Bot.Message> nextnext) {
            this.next = next;
            this.nextnext = nextnext;
        }
    }

    public static class Hello implements Message {
        ActorRef<Bot.Message> next;
        ActorRef<Bot.Message> nextnext;
        int counter;

        public Hello(ActorRef<Bot.Message> next, ActorRef<Bot.Message> nextnext, int counter) {
            this.next = next;
            this.nextnext = nextnext;
            this.counter = counter;
        }
    }

    public static Behavior<Message> create(String name) {
        return Behaviors.setup(context -> new Bot(context, name));
    }

    private final String name;

    private Bot(ActorContext<Message> context, String name) {
        super(context);
        this.name = name;
    }

    @Override
    public Receive<Message> createReceive() {
        return newReceiveBuilder()
                .onMessage(Hello.class, this::onHello)
                .onMessage(Start.class, this::onStart).build();
    }

    private Behavior<Message> onHello(Hello msg) {
        getContext().getLog().info("Hello {} for {}", msg.counter, this.name);
        if (msg.counter == 15) {
            return Behaviors.stopped();
        } else {
            msg.next.tell(new Hello(msg.nextnext, this.getContext().getSelf(), msg.counter+1));
            return this;
        }
    }

    private Behavior<Message> onStart(Start msg) {
        msg.next.tell(new Hello(msg.nextnext, this.getContext().getSelf(), 1));
        return this;
    }
}
