package com.example;

import akka.actor.typed.ActorRef;
import akka.actor.typed.Behavior;
import akka.actor.typed.javadsl.*;

public class MessageMain extends AbstractBehavior<MessageMain.Create> {

    public static class Create {
    }

    public static Behavior<Create> create() {
        return Behaviors.setup(MessageMain::new);
    }

    private MessageMain(ActorContext<Create> context) {
        super(context);
    }

    @Override
    public Receive<Create> createReceive() {
        return newReceiveBuilder().onMessage(Create.class, this::onCreate).build();
    }

    private Behavior<Create> onCreate(Create command) {
        //#create-actors
        ActorRef<Bot.Message> a = this.getContext().spawn(Bot.create("Alice"), "alice");
        ActorRef<Bot.Message> b = this.getContext().spawn(Bot.create("Bob"), "bob");
        ActorRef<Bot.Message> c = this.getContext().spawn(Bot.create("Charlie"), "charlie");
        //#create-actors

        a.tell(new Bot.Start(b,c));
        return this;
    }
}
